--***********************************************************
--**                    ROBERT JOHNSON                     **
--***********************************************************

require "TimedActions/ISBaseTimedAction"

UseExitAction = ISBaseTimedAction:derive("UseExitAction");

function UseExitAction:isValid()
	-- If the player is very thirsty, the destination item may get drained while filling it.
	-- When drained, the item may turn into another "empty" item, removing the item we're filling
	-- from it's container.
    -- if self.oldItem ~= nil then
        -- if self.oldItem and not self.oldItem:getContainer() then return false end
        -- return self.waterObject:hasWater()
    -- end
	-- if self.item and not self.item:getContainer() then return false end
	-- return self.waterObject:hasWater()
	return true
end

function UseExitAction:waitToStart()
    if self.elevator then
        self.character:faceThisObject(self.elevator)
    end
    return self.character:shouldBeTurning()
end

function UseExitAction:update()
    -- if self.item ~= nil then
        -- self.item:setJobDelta(self:getJobDelta());
        -- self.item:setUsedDelta(self.startUsedDelta + (self.endUsedDelta - self.startUsedDelta) * self:getJobDelta());
    -- end
    if self.elevator then
        self.character:faceThisObject(self.elevator);
    end
end

function UseExitAction:start()

		
	--self.character:playSound("Key2")
		--self:setActionAnim("fill_container_tap");
		
		if self.elevator2 == "Ladder" then 
			self:setActionAnim("fill_container_tap")
		else
			self.character:SetVariable("LootPosition", "Low");
		end
		self:setOverrideHandModels(nil, nil)
    -- end
end

function UseExitAction:stop()
    -- local used = self:getJobDelta() * self.waterUnit
    -- if used >= 1 then
		-- local obj = self.waterObject
		-- local args = {x=obj:getX(), y=obj:getY(), z=obj:getZ(), units=used}
		-- sendClientCommand(self.character, 'object', 'takeWater', args)
	-- end
    ISBaseTimedAction.stop(self);
    -- if self.item ~= nil then
		-- self.item:setBeingFilled(false)
        -- self.item:setJobDelta(0.0);
        -- if self.waterObject:isTaintedWater() then
            -- self.item:setTaintedWater(true);
        -- end
    -- end
end

function UseExitAction:perform()
	--player:Say("Exit PERFORM", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	
    ISBaseTimedAction.perform(self);
	--self.character:playSound("Beep2")
	print("Character 2 ?" .. tostring(self.character))
	Exit_Confirmation(self.character, self.elevator2, self.elevator)

	
end

function UseExitAction:new (character, card, elevator, elevator2, time)
	--player:Say("Exit NEW", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	local o = {}
	setmetatable(o, self)
	print("NEW Exit")
	print("Character?" .. tostring(character))
	self.__index = self
	o.character = character;
	o.card = card;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = 100 -- will set this in start()
	o.elevator = elevator;
	o.elevator2 = elevator2;
	--character:Say(tostring(elevator2), 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	return o
end

function Exit_Confirmation(playerObj, Elevator, Elevator2)

	print("Exit CONFIRMATION 1")
	print(tostring(Elevator))
	print(tostring(Elevator2:getSprite():getName()))
	
	--playerObj:Say(tostring(Elevator), 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	if Exit_ConfirmationDialog then
		Exit_ConfirmationDialog:destroy()
	end
	print("PLAYER???????????" .. tostring(playerObj))
	local player = playerObj:getPlayerNum()
	local width = 380;
	local x = getPlayerScreenLeft(player) + (getPlayerScreenWidth(player) - width) / 2
	local height = 120;
	local y = getPlayerScreenTop(player) + (getPlayerScreenHeight(player) * 0.7)
	--local modal = ISModalDialog:new(x,y, width, height, getText("Use " .. Elevator .. " to Exit?"), true, self, Exit_Confirmation2, player, playerObj, Elevator);
	local modal = ISModalDialog:new(x,y, width, height, getText("Use " .. Elevator .. " to Exit?"), true, self, Exit_Confirmation2, player, playerObj, Elevator2);
	--local modal = ISModalDialog:new(x,y, width, height, getText("Use Elevator?"), true, self, Exit_Confirmation2, playerObj);
	modal:initialise()
	Exit_ConfirmationDialog = modal
	modal:addToUIManager()
	modal:bringToTop()
	if JoypadState.players[player+1] then
		modal.prevFocus = JoypadState.players[player+1].focus
		setJoypadFocus(player, modal)
	end
end

function Exit_Confirmation2(unknown, button, player, Elevator2)
	local SpriteName = Elevator2:getSprite():getName()
	local Elavator = nil
	print("Exit CONFIRMATION 2")
	print(tostring(SpriteName))
			
		if SpriteName == "location_sewer_01_38" or SpriteName == "location_sewer_01_39" then
			if player:getClothingItem_Back() then
				player:Say("I need to take off my backpack.", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
				return
			else
				Elevator = "Sewer Pipe"
			end
		end
		if SpriteName =="street_decoration_01_15" then
			if player:getClothingItem_Back() then
				player:Say("I need to take off my backpack.", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
				return
			else
				Elevator = "Manhole"
			end
		end
		if SpriteName == "location_sewer_01_33" or SpriteName == "location_sewer_01_34" then
			if player:getPrimaryHandItem() or player:getSecondaryHandItem() then
				player:Say("I need to have my hands free.", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
				return
			else
				Elevator = "Ladder"
			end
		end	
	
	
		
	
	--player:Say(tostring(Elevator), 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	print("BUTTON2" .. tostring(button2))
	print("BUTTON3" .. tostring(player))
	--print("BUTTON4" .. tostring(playerObj))
	print("BUTTON5" .. tostring(Elevator))
	if button.internal == "YES" then
		print("PRINT YES")
		
	--player:Say("PRINT YES", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		--teleportToExit(player, Elevator)
		
	
		local teleport = nil
		
		
		if player:getSquare() ~= Elevator2:getSquare() then
			return
		
		end
		
		
		
		if Elevator == "Sewer Pipe" and (not player:getClothingItem_Back()) then
		--and Elevator2:getSquare() == player:getSquare() then
		 xx=5563
		 yy=12441
		 zz=0
		 teleport = true
		
		
		elseif Elevator == "Manhole" and (not player:getClothingItem_Back()) then
		--and Elevator2:getSquare() == player:getSquare() then
		 xx=5546
		 yy=12457
		 zz=0
		 teleport = true
		
		
		elseif Elevator == "Ladder" and (not player:getPrimaryHandItem()) and (not player:getSecondaryHandItem()) then
		--and Elevator2:getSquare() == player:getSquare() then
		 xx=5592
		 yy=12436
		 zz=0
		 teleport = nil
		 return
		
		
		end
		-- if Elevator == "Sewer Pipe" and ( player:getClothingItem_Back()) then
		 -- xx=5563
		 -- yy=12441
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		-- end
		-- if Elevator == "Manhole" and (player:getClothingItem_Back()) then
		 -- xx=5546
		 -- yy=12457
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		-- end
		-- if Elevator == "Ladder" and ( player:getPrimaryHandItem()) or ( player:getSecondaryHandItem()) then
		 -- xx=5592
		 -- yy=12436
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		
		-- end
		print("Can Teeport?" .. tostring(teleport))
		if teleport == true then 
			print("Player: " .. tostring(player))
			print("X: " .. xx)
			print("Y: " .. yy)
			print("Z: " .. zz)
			--player:setX(5530)--130
			--player:setY(12490)
			player:setX(xx)
			player:setY(yy)
			player:setZ(zz)
				--player:setLx(5477);
				--player:setLy(42378)
				player:setLx(xx);
				player:setLy(yy);--142, 202
		end
			
		
		-- print("YES")
		-- local xx=5542
		-- local yy=42502
		-- local zz=1
		-- print("Player: " .. tostring(player))
		-- print("X: " .. xx)
		-- print("Y: " .. yy)
		-- print("Z: " .. zz)
			-- --player:setX(5530)--130
			-- --player:setY(12490)
			-- player:setX(xx)
			-- player:setY(yy)
			-- player:setZ(zz)
				-- --player:setLx(5477);
				-- --player:setLy(42378)
				-- player:setLx(xx);
				-- player:setLy(yy);--142, 202
				-- player:setLz(zz);
		-- -- setGameSpeed(1)
		-- -- pauseSoundAndMusic()
		-- -- setShowPausedMessage(true)
		-- -- getCore():quitToDesktop()
	end
	if button.internal == "NO" then
		print("NO")
		
	--player:Say("PRINT NO", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		-- setGameSpeed(1)
		-- pauseSoundAndMusic()
		-- setShowPausedMessage(true)
		-- getCore():quitToDesktop()
	end
	--self.quitToDesktopDialog = nil
end


function teleportToExit(player, Elevatot)
		print("TELEPORT TO EXIT!")
	--player:Say(tostring(Elevator), 1.0, 0.0, 0.0, UIFont.Dialogue, 30.0, "radio")

	--player:Say("TELEPORT TO LABS!", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		local xx=5563
		local yy=12441
		local zz=0
		local teleport = nil
		if Elevator == "Sewer Pipe" and (not player:getClothingItem_Back()) then
		 xx=5563
		 yy=12441
		 zz=0
		 teleport = true
		
		
		elseif Elevator == "Manhole" and (not player:getClothingItem_Back()) then
		 xx=5546
		 yy=12457
		 zz=0
		 teleport = true
		
		
		elseif Elevator == "Ladder" and (not player:getPrimaryHandItem()) and (not player:getSecondaryHandItem()) then
		 xx=5592
		 yy=12436
		 zz=0
		 teleport = nil
		 return
		
		
		end
		-- if Elevator == "Sewer Pipe" and ( player:getClothingItem_Back()) then
		 -- xx=5563
		 -- yy=12441
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		-- end
		-- if Elevator == "Manhole" and (player:getClothingItem_Back()) then
		 -- xx=5546
		 -- yy=12457
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		-- end
		-- if Elevator == "Ladder" and ( player:getPrimaryHandItem()) or ( player:getSecondaryHandItem()) then
		 -- xx=5592
		 -- yy=12436
		 -- zz=0
		 -- teleport = nil
		 -- return
		
		
		-- end
		print("Can Teeport?" .. tostring(teleport))
		if teleport == true then 
			print("Player: " .. tostring(player))
			print("X: " .. xx)
			print("Y: " .. yy)
			print("Z: " .. zz)
			--player:setX(5530)--130
			--player:setY(12490)
			player:setX(xx)
			player:setY(yy)
			player:setZ(zz)
				--player:setLx(5477);
				--player:setLy(42378)
				player:setLx(xx);
				player:setLy(yy);--142, 202
				player:setLz(zz);
		end

end

function walkTo(playerObj, square, keepActions)
	if not keepActions then
		ISTimedActionQueue.clear(playerObj);
	end
--	if not AdjacentFreeTileFinder.isTileOrAdjacent(playerObj:getCurrentSquare(), square) then
		-- Avoid walking to already near spot
		local diffX = math.abs(square:getX() + 0.5 - playerObj:getX());
		local diffY = math.abs(square:getY() + 0.5 - playerObj:getY());
		if diffX <= 1.6 and diffY <= 1.6 then
			return true;
		end
        square = luautils.getCorrectSquareForWall(playerObj, square);
		--local adjacent = AdjacentFreeTileFinder.Find(square, playerObj);
		if square ~= nil then
			ISTimedActionQueue.add(ISWalkToTimedAction:new(playerObj, square));
			return true;
		else
			return  false;
		end
--	else
--		return true;
--	end
end