--***********************************************************
--**                    ROBERT JOHNSON                     **
--***********************************************************

require "TimedActions/ISBaseTimedAction"

UseKeycardAction = ISBaseTimedAction:derive("UseKeycardAction");

function UseKeycardAction:isValid()
	-- If the player is very thirsty, the destination item may get drained while filling it.
	-- When drained, the item may turn into another "empty" item, removing the item we're filling
	-- from it's container.
    -- if self.oldItem ~= nil then
        -- if self.oldItem and not self.oldItem:getContainer() then return false end
        -- return self.waterObject:hasWater()
    -- end
	-- if self.item and not self.item:getContainer() then return false end
	-- return self.waterObject:hasWater()
	return true
end

function UseKeycardAction:waitToStart()
    if self.elevator then
        self.character:faceThisObject(self.elevator)
    end
    return self.character:shouldBeTurning()
end

function UseKeycardAction:update()
    -- if self.item ~= nil then
        -- self.item:setJobDelta(self:getJobDelta());
        -- self.item:setUsedDelta(self.startUsedDelta + (self.endUsedDelta - self.startUsedDelta) * self:getJobDelta());
    -- end
    if self.elevator then
        self.character:faceThisObject(self.elevator);
    end
end

function UseKeycardAction:start()

		
	self.character:playSound("Key2")
		self:setActionAnim("fill_container_tap");
		self:setOverrideHandModels(nil, nil)
    -- end
end

function UseKeycardAction:stop()
    -- local used = self:getJobDelta() * self.waterUnit
    -- if used >= 1 then
		-- local obj = self.waterObject
		-- local args = {x=obj:getX(), y=obj:getY(), z=obj:getZ(), units=used}
		-- sendClientCommand(self.character, 'object', 'takeWater', args)
	-- end
    ISBaseTimedAction.stop(self);
    -- if self.item ~= nil then
		-- self.item:setBeingFilled(false)
        -- self.item:setJobDelta(0.0);
        -- if self.waterObject:isTaintedWater() then
            -- self.item:setTaintedWater(true);
        -- end
    -- end
end

function UseKeycardAction:perform()
	--player:Say("KEYCARD PERFORM", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	
    ISBaseTimedAction.perform(self);
	self.character:playSound("Beep2")
	print("Character 2 ?" .. tostring(self.character))
	Keycard_Confirmation(self.character,self.elevator)

	
end

function UseKeycardAction:new (character, card, elevator, time)
	--player:Say("KEYCARD NEW", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	local o = {}
	setmetatable(o, self)
	print("NEW KEYCARD")
	print("Character?" .. tostring(character))
	self.__index = self
	o.character = character;
	o.card = card;
	o.stopOnWalk = true;
	o.stopOnRun = true;
	o.maxTime = 100 -- will set this in start()
	o.elevator = elevator;
	return o
end

function Keycard_Confirmation(playerObj, Elevator)
	
	--playerObj:Say("KEYCARD CONFIRMATION 1", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	if Keycard_ConfirmationDialog then
		Keycard_ConfirmationDialog:destroy()
	end
	print("PLAYER???????????" .. tostring(playerObj))
	local player = playerObj:getPlayerNum()
	local width = 380;
	local x = getPlayerScreenLeft(player) + (getPlayerScreenWidth(player) - width) / 2
	local height = 120;
	local y = getPlayerScreenTop(player) + (getPlayerScreenHeight(player) * 0.7)
	local modal = ISModalDialog:new(x,y, width, height, getText("Use Elevator?"), true, self, Keycard_Confirmation2, player, playerObj, Elevator);
	--local modal = ISModalDialog:new(x,y, width, height, getText("Use Elevator?"), true, self, Keycard_Confirmation2, playerObj);
	modal:initialise()
	Keycard_ConfirmationDialog = modal
	modal:addToUIManager()
	modal:bringToTop()
	if JoypadState.players[player+1] then
		modal.prevFocus = JoypadState.players[player+1].focus
		setJoypadFocus(player, modal)
	end
end

function Keycard_Confirmation2(unknown, button, player, Elevator)
		local xx = player:getX()
		local yy = player:getY()
		
		if xx < 5542 or xx > 5544 then
			return false
		end

		if yy < 12501 or yy > 12504  then
			return false
		end
		
	print("KEYCARD CONFIRMATION 2")
	--player:Say("KEYCARD CONFIRMATION 2", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
	print("BUTTON2" .. tostring(button2))
	print("BUTTON3" .. tostring(player))
	if button.internal == "YES" then
		print("PRINT YES")
		
	--player:Say("PRINT YES", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		teleportToLabs(player)
		-- print("YES")
		-- local xx=5542
		-- local yy=42502
		-- local zz=1
		-- print("Player: " .. tostring(player))
		-- print("X: " .. xx)
		-- print("Y: " .. yy)
		-- print("Z: " .. zz)
			-- --player:setX(5530)--130
			-- --player:setY(12490)
			-- player:setX(xx)
			-- player:setY(yy)
			-- player:setZ(zz)
				-- --player:setLx(5477);
				-- --player:setLy(42378)
				-- player:setLx(xx);
				-- player:setLy(yy);--142, 202
				-- player:setLz(zz);
		-- -- setGameSpeed(1)
		-- -- pauseSoundAndMusic()
		-- -- setShowPausedMessage(true)
		-- -- getCore():quitToDesktop()
	end
	if button.internal == "NO" then
		print("NO")
		
	--player:Say("PRINT NO", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		-- setGameSpeed(1)
		-- pauseSoundAndMusic()
		-- setShowPausedMessage(true)
		-- getCore():quitToDesktop()
	end
	--self.quitToDesktopDialog = nil
end


function teleportToLabs(player)
		print("TELEPORT TO LABS!")

	--player:Say("TELEPORT TO LABS!", 1.0, 1.0, 1.0, UIFont.Dialogue, 30.0, "radio")
		local xx=5543
		local yy=42502
		local zz=1
		print("Player: " .. tostring(player))
		print("X: " .. xx)
		print("Y: " .. yy)
		print("Z: " .. zz)
			--player:setX(5530)--130
			--player:setY(12490)
			player:setX(xx)
			player:setY(yy)
			player:setZ(zz)
				--player:setLx(5477);
				--player:setLy(42378)
				player:setLx(xx);
				player:setLy(yy);--142, 202
				player:setLz(zz);


end
function teleportToBase(player)


		local xx=5545
		local yy=12500
		local zz=0
		print("Player: " .. tostring(player))
		print("X: " .. xx)
		print("Y: " .. yy)
		print("Z: " .. zz)
			--player:setX(5530)--130
			--player:setY(12490)
			player:setX(xx)
			player:setY(yy)
			player:setZ(zz)
				--player:setLx(5477);
				--player:setLy(42378)
				player:setLx(xx);
				player:setLy(yy);--142, 202
				player:setLz(zz);


end