local print = print
local getPlayer = getPlayer
local Say = Say
local ZombRand = ZombRand
local addVehicleDebug = addVehicleDebug
local tostring = tostring
local SandboxVars = SandboxVars
local setFallOnFront = setFallOnFront
local AddWorldInventoryItem = AddWorldInventoryItem
local getCell = getCell
local getGridSquare = getGridSquare
local createRandomDeadBody = createRandomDeadBody
local table = table
local format = string.format -- NOTE: we need this
local ipairs = ipairs
local getActivatedMods = getActivatedMods
local size = size
local get = get
local Dir = IsoDirections -- NOTE: dont pull every direction into local space, just the enum will do.

    
local DEBUG_MSG = false
--local MAX_RAND = 100 -- this is used to dictate the odds of all of the vehicles spawning; the higher the number, the less chance they spawn

local ManholeSpawnTable = { }

-- NOTE: function adding spawns, instead of nasty manual table inserts
-- this way we can define default values
local function addManholeSpawn(data)
    data.skin = data.skin or nil
    data.z = data.z or 0
    data.chance = data.chance or 100
    data.always = data.always or false
    
    -- instead of a list table, use a dict table. build the key off the string x,y,z position
    -- theres a number of ways of generating this string, in real lua this is fastest (kahlua needs confirmation) 
    local key = format("%i,%i,%i", data.x, data.y, data.z)
    ManholeSpawnTable[key] = data
end
-- basic function redundancy.
local function debugSay(text)
    if not DEBUG_MSG then return end
    print("DEBUG: ".. text)
    getPlayer():Say(text, 1.0, 1.0, 0.0, UIFont.Dialogue, 30.0, "radio")    
end
 
local function checkManholeSpawn(square)
    if not square then return end
   -- if square:getModData().spawnManhole then return end
    --square:getModData().spawnManhole = true
    local x, y, z = square:getX(), square:getY(), square:getZ()
    -- NOTE: build the key, and check the table, no need to itterate, or store mod data in the square 
    local key = format("%i,%i,%i", x, y, z)
    local spawn = ManholeSpawnTable[key]
    if not spawn then return end
	square:AddTileObject(IsoObject.new(square, spawn.type))
    --ManholeSpawnTable[key] = nil
end

Events.LoadGridsquare.Add(checkManholeSpawn) -- every time a grid square is loaded, checks for any vehicle spawn list entries

addManholeSpawn({type = "street_decoration_01_15", x = 5563, y = 12441})
addManholeSpawn({type = "street_decoration_01_15", x = 5546, y = 12457})
addManholeSpawn({type = "street_decoration_01_15", x = 5592, y = 12435})
